diff -crN nakedmudv2.0/src/scripts/script.c nakedmudv2.1/src/scripts/script.c
*** nakedmudv2.0/src/scripts/script.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/script.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 10,24 ****
  // script stuff
  #include <Python.h>
  #include <structmember.h>
- #include <compile.h>
- #include <eval.h>
- #include <node.h>
- //PyAPI_FUNC(PyObject *) PyEval_EvalCode(PyCodeObject *, PyObject *, PyObject *);
  
  // mud stuff
  #include "../mud.h"
  #include "../utils.h"
  #include "../socket.h"
  #include "../character.h"
  #include "../room.h"
  #include "../object.h"
--- 10,21 ----
  // script stuff
  #include <Python.h>
  #include <structmember.h>
  
  // mud stuff
  #include "../mud.h"
  #include "../utils.h"
  #include "../socket.h"
+ #include "../world.h"
  #include "../character.h"
  #include "../room.h"
  #include "../object.h"
***************
*** 40,50 ****
  
  
  //*****************************************************************************
  //
  // Auxiliary script data that we need to install into players, objects and
  // rooms. Essentially, this just allows these datastructures to actually have
  // scripts installed on them.
- //
  //*****************************************************************************
  typedef struct script_aux_data {
    SCRIPT_SET *scripts;    // the set of scripts that we have
--- 37,80 ----
  
  
  //*****************************************************************************
+ // local functions and commands
+ //*****************************************************************************
+ 
  //
+ // Takes a script and runs it. Unlike typical scripts, this is not a trigger.
+ // This is like running a program, in the form of a script.
+ //    usage: scrun <vnum> [arguments] 
+ COMMAND(cmd_scrun) {
+   // make sure we at least have a vnum
+   if(!arg || !*arg)
+     send_to_char(ch, "Which script would you like to run?\r\n");
+   else {
+     char buf[SMALL_BUFFER];
+ 
+     // pull out the vnum
+     arg = one_arg(arg, buf);
+ 
+     SCRIPT_DATA *script = worldGetScript(gameworld, atoi(buf));
+     if(script == NULL || !isdigit(*buf))
+       send_to_char(ch, "No script with that vnum exists!\r\n");
+     else if(scriptGetType(script) != SCRIPT_TYPE_RUNNABLE)
+       send_to_char(ch, "That script is not runnable!\r\n");
+     else if(charGetLevel(ch) < scriptGetNumArg(script))
+       send_to_char(ch, "You are not high enough level to run that script!\r\n");
+     else {
+       send_to_char(ch, "Ok.\r\n");
+       run_script(scriptGetCode(script), ch, SCRIPTOR_CHAR, NULL, NULL, NULL,
+ 		 NULL, arg, 0);
+     }
+   }
+ }
+ 
+ 
+ 
+ //*****************************************************************************
  // Auxiliary script data that we need to install into players, objects and
  // rooms. Essentially, this just allows these datastructures to actually have
  // scripts installed on them.
  //*****************************************************************************
  typedef struct script_aux_data {
    SCRIPT_SET *scripts;    // the set of scripts that we have
***************
*** 103,111 ****
  
  
  //*****************************************************************************
- //
  // functions for getting script data from various datastructures
- //
  //*****************************************************************************
  SCRIPT_SET *roomGetScripts(const ROOM_DATA *room) {
    SCRIPT_AUX_DATA *data = roomGetAuxiliaryData(room, "script_aux_data");
--- 133,139 ----
***************
*** 143,151 ****
  
  
  //*****************************************************************************
- //
  // functions 'n such for the script object
- //
  //*****************************************************************************
  struct script_data {
    script_vnum vnum;
--- 171,177 ----
***************
*** 163,176 ****
    "Give/Receive",
    "Enter",
    "Exit",
!   "Command"
  };
  
  const char *scriptTypeName(int num) {
    return script_type_info[num];
  }
  
! SCRIPT_DATA *newScript() {
    SCRIPT_DATA *script = malloc(sizeof(SCRIPT_DATA));
    bzero(script, sizeof(*script));
    
--- 189,203 ----
    "Give/Receive",
    "Enter",
    "Exit",
!   "Command",
!   "Runnable"
  };
  
  const char *scriptTypeName(int num) {
    return script_type_info[num];
  }
  
! SCRIPT_DATA *newScript(void) {
    SCRIPT_DATA *script = malloc(sizeof(SCRIPT_DATA));
    bzero(script, sizeof(*script));
    
***************
*** 293,301 ****
  
  
  //*****************************************************************************
- //
  // stuff we need for trying to run scripts
- //
  //*****************************************************************************
  
  //
--- 320,326 ----
***************
*** 456,461 ****
--- 481,488 ----
    extern COMMAND(cmd_scedit); // define the command
    add_cmd("scedit", NULL, cmd_scedit, 0, POS_UNCONCIOUS, POS_FLYING,
  	  LEVEL_SCRIPTER, FALSE, TRUE);
+   add_cmd("scrun", NULL, cmd_scrun, 0, POS_UNCONCIOUS, POS_FLYING,
+ 	  LEVEL_BUILDER, FALSE, FALSE);
  
    init_script_editor();
  }
***************
*** 522,530 ****
  
  
  //*****************************************************************************
- //
  // Stuff we need for formatting and coloring scripts on screen
- //
  //*****************************************************************************
  void format_script(char **script, int max_len) {
    // python chokes on carriage returns
--- 549,555 ----
***************
*** 680,688 ****
  
  
  //*****************************************************************************
- //
  // tries for various speech triggers
- //
  //*****************************************************************************
  void try_speech_script_with(CHAR_DATA *ch, CHAR_DATA *listener, char *speech) {
    LIST *speech_scripts = scriptSetList(charGetScripts(listener), 
--- 705,711 ----
***************
*** 793,802 ****
      scripts = scriptSetList(roomGetScripts(me), script_type);
    if(me_type == SCRIPTOR_OBJ)
      scripts = scriptSetList(objGetScripts(me), script_type);
-   /*
-   if(me_type == SCRIPTOR_EXIT)
-     scripts = scriptSetGetList(exitGetScripts(me), script_type);
-   */
  
    // see if we meet the script requirements
    while( (script = listPop(scripts)) != NULL) {
--- 816,821 ----
diff -crN nakedmudv2.0/src/scripts/script_edit.c nakedmudv2.1/src/scripts/script_edit.c
*** nakedmudv2.0/src/scripts/script_edit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/script_edit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 51,58 ****
  		 );
  }
  
! int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, char option) {
!   switch(toupper(option)) {
    case 'N':
      text_to_buffer(sock, "Which script would you like to add (-1 for none): ");
      return SSEDIT_NEW;
--- 51,58 ----
  		 );
  }
  
! int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, const char *option) {
!   switch(toupper(*option)) {
    case 'N':
      text_to_buffer(sock, "Which script would you like to add (-1 for none): ");
      return SSEDIT_NEW;
***************
*** 106,118 ****
    script_display(sock, scriptGetCode(script), FALSE);
  }
  
! int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, char option) {
!   switch(toupper(option)) {
    case '1':
      text_to_buffer(sock, "Enter a new name for the script: ");
      return SCEDIT_NAME;
    case '2':
      olc_display_table(sock, scriptTypeName, NUM_SCRIPTS, 1);
      return SCEDIT_TYPE;
    case '3':
      text_to_buffer(sock, "Enter new arguments: ");
--- 106,119 ----
    script_display(sock, scriptGetCode(script), FALSE);
  }
  
! int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, const char *option){
!   switch(toupper(*option)) {
    case '1':
      text_to_buffer(sock, "Enter a new name for the script: ");
      return SCEDIT_NAME;
    case '2':
      olc_display_table(sock, scriptTypeName, NUM_SCRIPTS, 1);
+     text_to_buffer(sock, "Pick a script type: ");
      return SCEDIT_TYPE;
    case '3':
      text_to_buffer(sock, "Enter new arguments: ");
***************
*** 134,139 ****
--- 135,145 ----
  		     "Enter choice : ");
        return SCEDIT_NARG;
  
+     case SCRIPT_TYPE_RUNNABLE:
+       send_to_socket(sock,
+ 		     "Enter the minimum level that can run this script: ");
+       return SCEDIT_NARG;
+ 
      case SCRIPT_TYPE_COMMAND:
        send_to_socket(sock,
  		     "Control for the actual MUD command:\r\n"
***************
*** 180,185 ****
--- 186,195 ----
      case SCRIPT_TYPE_COMMAND:
        scriptSetNumArg(script, MIN(1, MAX(0, atoi(arg))));
        break;
+       // narg = minimum level that can run this script
+     case SCRIPT_TYPE_RUNNABLE:
+       scriptSetNumArg(script, MIN(MAX_LEVEL, MAX(0, atoi(arg))));
+       break;
      }
      return TRUE;
  
diff -crN nakedmudv2.0/src/scripts/script_editor.c nakedmudv2.1/src/scripts/script_editor.c
*** nakedmudv2.0/src/scripts/script_editor.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/script_editor.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 45,50 ****
--- 45,51 ----
  void scriptEditorIndent(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
    SCRIPT_EDITOR_AUX_DATA *data = socketGetAuxiliaryData(sock, "script_editor_aux_data");
    data->indent += 2;
+   send_to_socket(sock, "Editor indented to %d spaces.\r\n", data->indent);
  }
  
  //
***************
*** 54,59 ****
--- 55,61 ----
    data->indent -= 2;
    if(data->indent < 0)
      data->indent = 0;
+   send_to_socket(sock, "Editor undented to %d spaces.\r\n", data->indent);
  }
  
  //
***************
*** 103,108 ****
--- 105,111 ----
  // \r really screws up python; this function makes sure they're all stripped out
  void scriptEditorFormat(SOCKET_DATA *sock, char *arg, BUFFER *buf) {
    bufferReplace(buf, "\r", "", TRUE);
+   text_to_buffer(sock, "Script formatted.\r\n");
  }
  
  //
***************
*** 112,117 ****
--- 115,135 ----
    data->indent = 0;
  }
  
+ //
+ // bufferInsert appends a carriage return to the end of the argument, but this
+ // makes Python choke. Soooo... we have to do the append, and then remove the
+ // carriage return that was inserted.
+ void scriptEditorInsert(SOCKET_DATA *sock, char *arg, BUFFER *buf) { 
+   char tmp[SMALL_BUFFER];
+   arg = one_arg(arg, tmp);
+   int line = atoi(tmp);
+   if(!isdigit(*tmp) || !bufferInsert(buf, arg, line))
+     text_to_buffer(sock, "Insertion failed.\r\n");
+   else {
+     text_to_buffer(sock, "Line inserted");
+     bufferReplace(buf, "\r", "", TRUE);    
+   }
+ }
  
  
  //*****************************************************************************
***************
*** 129,134 ****
--- 147,154 ----
  		   scriptEditorList);
    editorAddCommand(script_editor, "f", "        Strips all bad characters out of the script",
  		   scriptEditorFormat);
+   editorAddCommand(script_editor, "i", "# <txt> Insert new text at the specified line number",
+ 		   scriptEditorInsert);
  
    auxiliariesInstall("script_editor_aux_data", 
  		     newAuxiliaryFuncs(AUXILIARY_TYPE_SOCKET,
diff -crN nakedmudv2.0/src/scripts/script.h nakedmudv2.1/src/scripts/script.h
*** nakedmudv2.0/src/scripts/script.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/scripts/script.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 136,141 ****
--- 136,156 ----
  //     arg  = the argument supplied to the command
  
  //*****************************************************************************
+ // SCRIPT_TYPE_RUNNABLE
+ //   Description:
+ //     Gods can use scrun to run a script of this type
+ //   Arguments:
+ //     The Arguments to be passed to the script
+ //   Numeric Arguments:
+ //     Argument is the minimum level of a person who is allowed to 
+ //     run this this script
+ //   Works with:
+ //     mobiles (gods)
+ //   Parameters:
+ //     me   = the person running the script
+ //     arg  = the argument supplied to scrun
+ 
+ //*****************************************************************************
  #define SCRIPT_TYPE_NONE          (-1)
  #define SCRIPT_TYPE_INIT            0 // when the room/mob/obj resets or loads
  #define SCRIPT_TYPE_SPEECH          1 // when someone says a keyword
***************
*** 144,155 ****
  #define SCRIPT_TYPE_ENTER           4 // when a char enters the room
  #define SCRIPT_TYPE_EXIT            5 // when the character exits the room 
  #define SCRIPT_TYPE_COMMAND         6 // when a command is issued
! #define NUM_SCRIPTS                 7
  
  
  const char *scriptTypeName(int num);
  
! SCRIPT_DATA *newScript   ();
  void         deleteScript(SCRIPT_DATA *script);
  
  STORAGE_SET *scriptStore(SCRIPT_DATA *script);
--- 159,171 ----
  #define SCRIPT_TYPE_ENTER           4 // when a char enters the room
  #define SCRIPT_TYPE_EXIT            5 // when the character exits the room 
  #define SCRIPT_TYPE_COMMAND         6 // when a command is issued
! #define SCRIPT_TYPE_RUNNABLE        7 // intended for people to run
! #define NUM_SCRIPTS                 8
  
  
  const char *scriptTypeName(int num);
  
! SCRIPT_DATA *newScript   (void);
  void         deleteScript(SCRIPT_DATA *script);
  
  STORAGE_SET *scriptStore(SCRIPT_DATA *script);
***************
*** 193,203 ****
  //
  #ifdef MODULE_OLC2
  void ssedit_menu   (SOCKET_DATA *sock, SCRIPT_SET *set);
! int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, char option);
  bool ssedit_parser (SOCKET_DATA *sock, SCRIPT_SET *set, int choice, 
  		    const char *arg);
  void scedit_menu   (SOCKET_DATA *sock, SCRIPT_DATA *script);
! int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, char option);
  bool scedit_parser (SOCKET_DATA *sock, SCRIPT_DATA *script, int choice, 
  		    const char *arg);
  #endif // MODULE_OLC2
--- 209,219 ----
  //
  #ifdef MODULE_OLC2
  void ssedit_menu   (SOCKET_DATA *sock, SCRIPT_SET *set);
! int  ssedit_chooser(SOCKET_DATA *sock, SCRIPT_SET *set, const char *option);
  bool ssedit_parser (SOCKET_DATA *sock, SCRIPT_SET *set, int choice, 
  		    const char *arg);
  void scedit_menu   (SOCKET_DATA *sock, SCRIPT_DATA *script);
! int  scedit_chooser(SOCKET_DATA *sock, SCRIPT_DATA *script, const char *option);
  bool scedit_parser (SOCKET_DATA *sock, SCRIPT_DATA *script, int choice, 
  		    const char *arg);
  #endif // MODULE_OLC2
diff -crN nakedmudv2.0/src/set.c nakedmudv2.1/src/set.c
*** nakedmudv2.0/src/set.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/set.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 12,17 ****
--- 12,18 ----
  
  struct set_data {
    int    num_buckets;
+   int    size;
    LIST **buckets;
  };
  
***************
*** 22,53 ****
  };
  
  
  //*****************************************************************************
- //
  // local functions
- //
  //*****************************************************************************
  
  
  //
  // Find the bucket the set element belongs to
- //
  int set_elem_bucket(void *elem, int num_buckets) {
    // simple for now: just take the modulo
    return ((int)elem) % num_buckets;
  };
  
  
  //*****************************************************************************
- //
  // implementation of set.h
- //
  //*****************************************************************************
  SET *newSet(int num_buckets) {
    int i;
  
    SET *set = malloc(sizeof(SET));
    set->buckets = malloc(sizeof(LIST *) * num_buckets);
  
    // all NULL until they actually get a content
    for(i = 0; i < num_buckets; i++)
--- 23,52 ----
  };
  
  
+ 
  //*****************************************************************************
  // local functions
  //*****************************************************************************
  
  
  //
  // Find the bucket the set element belongs to
  int set_elem_bucket(void *elem, int num_buckets) {
    // simple for now: just take the modulo
    return ((int)elem) % num_buckets;
  };
  
  
+ 
  //*****************************************************************************
  // implementation of set.h
  //*****************************************************************************
  SET *newSet(int num_buckets) {
    int i;
  
    SET *set = malloc(sizeof(SET));
    set->buckets = malloc(sizeof(LIST *) * num_buckets);
+   set->size    = 0;
  
    // all NULL until they actually get a content
    for(i = 0; i < num_buckets; i++)
***************
*** 57,63 ****
    return set;
  };
  
- 
  void deleteSet(SET *set) {
    int i;
  
--- 56,61 ----
***************
*** 69,75 ****
    free(set);
  };
  
- 
  void setPut(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
--- 67,72 ----
***************
*** 81,87 ****
    listPut(set->buckets[hash_bucket], elem);
  };
  
- 
  void setRemove(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
--- 78,83 ----
***************
*** 91,97 ****
      listRemove(set->buckets[hash_bucket], elem);
  };
  
- 
  int setIn(SET *set, void *elem) {
    // find out what bucket we belong to
    int hash_bucket = set_elem_bucket(elem, set->num_buckets);
--- 87,92 ----
***************
*** 103,115 ****
  };
  
  
  //*****************************************************************************
- //
  // set iterator
  //
  // we may sometimes want to iterate across all of the elements in a set.
  // this lets us do so.
- //
  //*****************************************************************************
  SET_ITERATOR *newSetIterator(SET *S) {
    SET_ITERATOR *I = malloc(sizeof(SET_ITERATOR));
--- 98,109 ----
  };
  
  
+ 
  //*****************************************************************************
  // set iterator
  //
  // we may sometimes want to iterate across all of the elements in a set.
  // this lets us do so.
  //*****************************************************************************
  SET_ITERATOR *newSetIterator(SET *S) {
    SET_ITERATOR *I = malloc(sizeof(SET_ITERATOR));
diff -crN nakedmudv2.0/src/set_val/set_val.c nakedmudv2.1/src/set_val/set_val.c
*** nakedmudv2.0/src/set_val/set_val.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/set_val/set_val.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 32,38 ****
  // local defines, datastructures, functions, and commands
  //
  //*****************************************************************************
- #define SET_TABLE_SIZE        10
  HASHTABLE *char_set_table = NULL;
  HASHTABLE *obj_set_table  = NULL;
  HASHTABLE *room_set_table = NULL;
--- 32,37 ----
***************
*** 179,187 ****
  //*****************************************************************************
  void init_set() {
    // build all of our tables
!   char_set_table = newHashtable(SET_TABLE_SIZE);
!   obj_set_table  = newHashtable(SET_TABLE_SIZE);
!   room_set_table = newHashtable(SET_TABLE_SIZE);
  
    // add in the default sets for the core of the MUD
    /************************************************************/
--- 178,186 ----
  //*****************************************************************************
  void init_set() {
    // build all of our tables
!   char_set_table = newHashtable();
!   obj_set_table  = newHashtable();
!   room_set_table = newHashtable();
  
    // add in the default sets for the core of the MUD
    /************************************************************/
diff -crN nakedmudv2.0/src/socials/socedit.c nakedmudv2.1/src/socials/socedit.c
*** nakedmudv2.0/src/socials/socedit.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/socials/socedit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 56,63 ****
  		 );
  }
  
! int  socedit_chooser(SOCKET_DATA *sock, SOCIAL_DATA *social, char option) {
!   switch(toupper(option)) {
    case '1':
      send_to_socket(sock, 
  		   "The message to character when no target is supplied : ");
--- 56,63 ----
  		 );
  }
  
! int  socedit_chooser(SOCKET_DATA *sock, SOCIAL_DATA *social,const char *option){
!   switch(toupper(*option)) {
    case '1':
      send_to_socket(sock, 
  		   "The message to character when no target is supplied : ");
***************
*** 88,96 ****
--- 88,98 ----
      return SOCEDIT_ROOM_TGT;
    case '8':
      olc_display_table(sock, posGetName, NUM_POSITIONS, 2);
+     text_to_buffer(sock, "Pick a minimum position: ");
      return SOCEDIT_MIN_POS;
    case '9':
      olc_display_table(sock, posGetName, NUM_POSITIONS, 2);
+     text_to_buffer(sock, "Pick a maximum position: ");
      return SOCEDIT_MAX_POS;
    default: 
      return MENU_CHOICE_INVALID;
diff -crN nakedmudv2.0/src/socials/socials.c nakedmudv2.1/src/socials/socials.c
*** nakedmudv2.0/src/socials/socials.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/socials/socials.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 30,38 ****
  // the file where all of the socials are stored
  #define SOCIALS_FILE "../lib/misc/socials"
  
- // how many buckets are there in the social table
- #define SOCIAL_TABLE_SIZE              100
- 
  // the table we store all of the socials in
  HASHTABLE *social_table = NULL;
  
--- 30,35 ----
***************
*** 439,445 ****
  
  void init_socials() {
    // create the social table
!   social_table = newHashtable(SOCIAL_TABLE_SIZE);
  
    // open up the storage set
    STORAGE_SET       *set = storage_read(SOCIALS_FILE);
--- 436,442 ----
  
  void init_socials() {
    // create the social table
!   social_table = newHashtable();
  
    // open up the storage set
    STORAGE_SET       *set = storage_read(SOCIALS_FILE);
diff -crN nakedmudv2.0/src/storage.c nakedmudv2.1/src/storage.c
*** nakedmudv2.0/src/storage.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/storage.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 500,506 ****
  
  STORAGE_SET *new_storage_set() {
    STORAGE_SET *set = malloc(sizeof(STORAGE_SET));
!   set->entries     = newHashtable(20);
    set->longest_key = 0;
    set->top_entry   = 0;
    return set;
--- 500,506 ----
  
  STORAGE_SET *new_storage_set() {
    STORAGE_SET *set = malloc(sizeof(STORAGE_SET));
!   set->entries     = newHashtableSize(20);
    set->longest_key = 0;
    set->top_entry   = 0;
    return set;
diff -crN nakedmudv2.0/src/utils.c nakedmudv2.1/src/utils.c
*** nakedmudv2.0/src/utils.c	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/utils.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 881,890 ****
    return count;
  }
  
- 
- //
- // returns a random number in the specified range (inclusive)
- //
  int rand_number(int min, int max) {
    if(min > max) {
      log_string("ERROR: rand_number passed a min (%d) higher than its max (%d).",
--- 881,886 ----
***************
*** 895,900 ****
--- 891,904 ----
    return min + rand() % (max-min + 1);
  }
  
+ double rand_percent(void) {
+   double rnd = rand_number(0, RAND_MAX);
+   return rnd / (double)RAND_MAX;
+ }
+ 
+ double gaussian(void) {
+   return sqrt(-2.0 * log(rand_percent())) * cos(2.0 * PI * rand_percent());
+ }
  
  //
  // returns "st", "nd", "rd", or "th", based on the number passed in
diff -crN nakedmudv2.0/src/utils.h nakedmudv2.1/src/utils.h
*** nakedmudv2.0/src/utils.h	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/src/utils.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 15,25 ****
--- 15,45 ----
  // Utilities for numbers
  //
  //*****************************************************************************
+ #define MAX_INT               214743648
+ #define PI                    3.14159265
+ 
  #define UMIN(a, b)	      ((a) < (b) ? (a) : (b))
  #define MIN(a, b)             ((a) < (b) ? (a) : (b))
  #define MAX(a, b)             ((a) < (b) ? (b) : (a))
  
+ 
+ //
+ // return a random number pulled from a uniform distribution 
+ // between the two bounds
  int rand_number(int min, int max);
+ 
+ 
+ //
+ // Returns a random number between 0 and 1. Numbers are evenly distributed
+ double rand_percent(void);
+ 
+ //
+ // Return a random number pulled from N(0, 1)
+ double gaussian(void);
+ 
+ 
+ //
+ // return the rd, th, nd, for a number
  const char *numth(int num);
  
  
diff -crN nakedmudv2.0/TODO nakedmudv2.1/TODO
*** nakedmudv2.0/TODO	2010-11-01 15:54:18.000000000 -0500
--- nakedmudv2.1/TODO	2010-11-01 15:54:18.000000000 -0500
***************
*** 7,16 ****
  
  +-- NOT COMPLETE
   +-- HIGH PRIORITY
!    * bedit -> bitvector edit
!    * create an insert function for the script editor that kills carraige returns
     * redo sets to be in a tree form rather than a table form
!    * redo hashtables so that they will auto-enlarge themselves
     * Rewrite the character creation input handling stuff; it's kludgy
     * character positions and changing of positions is a bit of a hack.
       it could really do with some cleaning up. Move their defines to mud.h
--- 7,16 ----
  
  +-- NOT COMPLETE
   +-- HIGH PRIORITY
!    * set up accounts instead of having players log in directly
!    * make python objects (mob, obj, room) extendable from outside modules
     * redo sets to be in a tree form rather than a table form
!    * make property tables auto-enlarge theirselves when they get too big
     * Rewrite the character creation input handling stuff; it's kludgy
     * character positions and changing of positions is a bit of a hack.
       it could really do with some cleaning up. Move their defines to mud.h
***************
*** 22,36 ****
       editing stuff (it's a hack...).
  
   +-- LOW PRIORITY
!    * Mysty's Dialog
!      * Betta
!      * Oren
     * make tracking use BFS instead of DFS
     * Bulletin board/forum system
     * soft-code chat channels
     * spellchecking in the text editor
     * mounts and vehicles
!    * shops (for mobiles and players)
     * customized prompts
     * DOCUMENT DOCUMENT DOCUMENT!! Most of the major headers need full
       documentation still.
--- 22,34 ----
       editing stuff (it's a hack...).
  
   +-- LOW PRIORITY
!    * Mysty's Dialog: Betta, Oren
     * make tracking use BFS instead of DFS
     * Bulletin board/forum system
     * soft-code chat channels
     * spellchecking in the text editor
     * mounts and vehicles
!    * currency and shops (for mobiles and players)
     * customized prompts
     * DOCUMENT DOCUMENT DOCUMENT!! Most of the major headers need full
       documentation still.
***************
*** 46,48 ****
--- 44,48 ----
      responses
  
  +-- NEEDS DEBUGGING
+    * redo hashtables so that they will auto-enlarge themselves
+    * olc should pass a whole argument to the command funcs
